// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.13.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.DataLake.Analytics.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// A Data Lake Analytics catalog U-SQL view item.
    /// </summary>
    public partial class USqlView
    {
        /// <summary>
        /// Initializes a new instance of the USqlView class.
        /// </summary>
        public USqlView() { }

        /// <summary>
        /// Initializes a new instance of the USqlView class.
        /// </summary>
        public USqlView(string databaseName = default(string), string schemaName = default(string), string viewName = default(string), string definition = default(string), string computeAccountName = default(string), string version = default(string))
        {
            DatabaseName = databaseName;
            SchemaName = schemaName;
            ViewName = viewName;
            Definition = definition;
            ComputeAccountName = computeAccountName;
            Version = version;
        }

        /// <summary>
        /// Gets or sets the name of the database.
        /// </summary>
        [JsonProperty(PropertyName = "databaseName")]
        public string DatabaseName { get; set; }

        /// <summary>
        /// Gets or sets the name of the schema associated with this view and
        /// database.
        /// </summary>
        [JsonProperty(PropertyName = "schemaName")]
        public string SchemaName { get; set; }

        /// <summary>
        /// Gets or sets the name of the view.
        /// </summary>
        [JsonProperty(PropertyName = "viewName")]
        public string ViewName { get; set; }

        /// <summary>
        /// Gets or sets the defined query of the view.
        /// </summary>
        [JsonProperty(PropertyName = "definition")]
        public string Definition { get; set; }

        /// <summary>
        /// Gets or sets the name of the Data Lake Analytics account.
        /// </summary>
        [JsonProperty(PropertyName = "computeAccountName")]
        public string ComputeAccountName { get; set; }

        /// <summary>
        /// Gets or sets the version of the catalog item.
        /// </summary>
        [JsonProperty(PropertyName = "version")]
        public string Version { get; set; }

    }
}
