// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.OperationalInsights.Models
{
    /// <summary>
    /// Management group properties.
    /// </summary>
    public partial class ManagementGroupProperties
    {
        private System.DateTime? _created;
        
        /// <summary>
        /// Optional. Gets or sets the datetime that the management group was
        /// created.
        /// </summary>
        public System.DateTime? Created
        {
            get { return this._created; }
            set { this._created = value; }
        }
        
        private System.DateTime? _dataReceived;
        
        /// <summary>
        /// Optional. Gets or sets the last datetime that the management group
        /// received data.
        /// </summary>
        public System.DateTime? DataReceived
        {
            get { return this._dataReceived; }
            set { this._dataReceived = value; }
        }
        
        private System.Guid? _id;
        
        /// <summary>
        /// Optional. Gets or sets the unique ID of the management group.
        /// </summary>
        public System.Guid? Id
        {
            get { return this._id; }
            set { this._id = value; }
        }
        
        private bool _isGateway;
        
        /// <summary>
        /// Optional. Gets or sets a value indicating whether the management
        /// group is a gateway.
        /// </summary>
        public bool IsGateway
        {
            get { return this._isGateway; }
            set { this._isGateway = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Optional. Gets or sets the name of the management group.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private int _serverCount;
        
        /// <summary>
        /// Optional. Gets or sets the number of servers connected to the
        /// management group.
        /// </summary>
        public int ServerCount
        {
            get { return this._serverCount; }
            set { this._serverCount = value; }
        }
        
        private string _sku;
        
        /// <summary>
        /// Optional. Gets or sets the SKU of System Center that is managing
        /// the management group.
        /// </summary>
        public string Sku
        {
            get { return this._sku; }
            set { this._sku = value; }
        }
        
        private string _version;
        
        /// <summary>
        /// Optional. Gets or sets the version of System Center that is
        /// managing the management group.
        /// </summary>
        public string Version
        {
            get { return this._version; }
            set { this._version = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ManagementGroupProperties class.
        /// </summary>
        public ManagementGroupProperties()
        {
        }
    }
}
