// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.13.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Search.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Represents parameters for indexer execution.
    /// </summary>
    public partial class IndexingParameters
    {
        /// <summary>
        /// Initializes a new instance of the IndexingParameters class.
        /// </summary>
        public IndexingParameters() { }

        /// <summary>
        /// Initializes a new instance of the IndexingParameters class.
        /// </summary>
        public IndexingParameters(int? maxFailedItems = default(int?), int? maxFailedItemsPerBatch = default(int?), bool? base64EncodeKeys = default(bool?))
        {
            MaxFailedItems = maxFailedItems;
            MaxFailedItemsPerBatch = maxFailedItemsPerBatch;
            Base64EncodeKeys = base64EncodeKeys;
        }

        /// <summary>
        /// Gets or sets the maximum number of items that can fail indexing
        /// for indexer execution to still be considered successful. -1 means
        /// no limit. Default is 0.
        /// </summary>
        [JsonProperty(PropertyName = "maxFailedItems")]
        public int? MaxFailedItems { get; set; }

        /// <summary>
        /// Gets or sets the maximum number of items in a single batch that
        /// can fail indexing for the batch to still be considered
        /// successful. -1 means no limit. Default is 0.
        /// </summary>
        [JsonProperty(PropertyName = "maxFailedItemsPerBatch")]
        public int? MaxFailedItemsPerBatch { get; set; }

        /// <summary>
        /// Gets or sets whether indexer will base64-encode all values that
        /// are inserted into key field of the target index. This is needed
        /// if keys can contain characters that are invalid in keys (such as
        /// dot '.'). Default is false.
        /// </summary>
        [JsonProperty(PropertyName = "base64EncodeKeys")]
        public bool? Base64EncodeKeys { get; set; }

    }
}
