// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.WindowsAzure.Management.Compute.Models;

namespace Microsoft.WindowsAzure.Management.Compute.Models
{
    /// <summary>
    /// A list of internal load balancers that each provide load balancing on a
    /// private VIP.
    /// </summary>
    public partial class LoadBalancer
    {
        private FrontendIPConfiguration _frontendIPConfiguration;
        
        /// <summary>
        /// Optional. The configuration for the virtual IP address (VIP) this
        /// load balancer provides.
        /// </summary>
        public FrontendIPConfiguration FrontendIPConfiguration
        {
            get { return this._frontendIPConfiguration; }
            set { this._frontendIPConfiguration = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Optional. The name of the load balancer.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the LoadBalancer class.
        /// </summary>
        public LoadBalancer()
        {
        }
    }
}
