// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;

namespace Microsoft.WindowsAzure.Management.RemoteApp.Models
{
    /// <summary>
    /// Definition containing details of Start Menu Applications.
    /// </summary>
    public partial class StartMenuApplication
    {
        private string _commandLineArguments;
        
        /// <summary>
        /// Optional. The command line arguments to launch the application.
        /// </summary>
        public string CommandLineArguments
        {
            get { return this._commandLineArguments; }
            set { this._commandLineArguments = value; }
        }
        
        private IDictionary<int, string> _iconPngUris;
        
        /// <summary>
        /// Optional. The available map of icon PNG file URIs for different
        /// resolutions (e.g. 16x16, 32x32, 64x64). The key of the map is the
        /// first dimension of the PNG resolution.
        /// </summary>
        public IDictionary<int, string> IconPngUris
        {
            get { return this._iconPngUris; }
            set { this._iconPngUris = value; }
        }
        
        private string _iconUri;
        
        /// <summary>
        /// Optional. The default URI to the application icon png file.
        /// </summary>
        public string IconUri
        {
            get { return this._iconUri; }
            set { this._iconUri = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Required. The application name.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private string _startMenuAppId;
        
        /// <summary>
        /// Optional. The start menu application id.
        /// </summary>
        public string StartMenuAppId
        {
            get { return this._startMenuAppId; }
            set { this._startMenuAppId = value; }
        }
        
        private string _virtualPath;
        
        /// <summary>
        /// Optional. The application image path on the destination machine
        /// specified with environment variables for the drive and known
        /// system path.
        /// </summary>
        public string VirtualPath
        {
            get { return this._virtualPath; }
            set { this._virtualPath = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the StartMenuApplication class.
        /// </summary>
        public StartMenuApplication()
        {
            this.IconPngUris = new LazyDictionary<int, string>();
        }
        
        /// <summary>
        /// Initializes a new instance of the StartMenuApplication class with
        /// required arguments.
        /// </summary>
        public StartMenuApplication(string name)
            : this()
        {
            if (name == null)
            {
                throw new ArgumentNullException("name");
            }
            this.Name = name;
        }
    }
}
