// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.WindowsAzure.Scheduler.Models;

namespace Microsoft.WindowsAzure.Scheduler.Models
{
    /// <summary>
    /// Parameters supplied to the List Jobs with filter operation.
    /// </summary>
    public partial class JobListWithFilterParameters : JobListParameters
    {
        private JobState _state;
        
        /// <summary>
        /// Required. Filter the job history to have it only return job
        /// execution attempts having a particular State, enabled, disabled,
        /// faulted, or completed.
        /// </summary>
        public JobState State
        {
            get { return this._state; }
            set { this._state = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the JobListWithFilterParameters class.
        /// </summary>
        public JobListWithFilterParameters()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the JobListWithFilterParameters class
        /// with required arguments.
        /// </summary>
        public JobListWithFilterParameters(JobState state)
            : this()
        {
            this.State = state;
        }
    }
}
