// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.StorSimple.Models
{
    /// <summary>
    /// Device AlertNotificationSettings
    /// </summary>
    public partial class AlertNotificationSettings
    {
        private string _alertNotifcationCulture;
        
        /// <summary>
        /// Optional. Gets or sets the AlertNotifcationCulture
        /// </summary>
        public string AlertNotifcationCulture
        {
            get { return this._alertNotifcationCulture; }
            set { this._alertNotifcationCulture = value; }
        }
        
        private bool _alertNotifcationEnabled;
        
        /// <summary>
        /// Required. Gets or sets the AlertNotifcationEnabled
        /// </summary>
        public bool AlertNotifcationEnabled
        {
            get { return this._alertNotifcationEnabled; }
            set { this._alertNotifcationEnabled = value; }
        }
        
        private IList<string> _alertNotificationEmailList;
        
        /// <summary>
        /// Optional. Gets or Sets non-admin recipients for email alerts. This
        /// can also include distribution groups apart from regular email ids
        /// </summary>
        public IList<string> AlertNotificationEmailList
        {
            get { return this._alertNotificationEmailList; }
            set { this._alertNotificationEmailList = value; }
        }
        
        private bool _alertNotificationEnabledForAdminCoAdmins;
        
        /// <summary>
        /// Optional. Gets or sets flag enabling/disabling alert emails for
        /// admins and coadmins
        /// </summary>
        public bool AlertNotificationEnabledForAdminCoAdmins
        {
            get { return this._alertNotificationEnabledForAdminCoAdmins; }
            set { this._alertNotificationEnabledForAdminCoAdmins = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the AlertNotificationSettings class.
        /// </summary>
        public AlertNotificationSettings()
        {
            this.AlertNotificationEmailList = new List<string>();
        }
        
        /// <summary>
        /// Initializes a new instance of the AlertNotificationSettings class
        /// with required arguments.
        /// </summary>
        public AlertNotificationSettings(bool alertNotifcationEnabled)
            : this()
        {
            this.AlertNotifcationEnabled = alertNotifcationEnabled;
        }
    }
}
